#include<stdio.h>
#include<assert.h>
#include<math.h>
#define EPSILON 0.00001
/*********************************************************************
 * This program uses the divide and conquer method of finding 
 * approximate roots to approximate the root of a function given an
 * endpoint at which the function is negative and an endpoint at 
 * which the function is positive. The user supplies the endpoints
 * from the keyboard.
 */
void swap(double *a, double *b);/* Interchange the values. */
/* This approximates the root of f between left and right. */
double find_zero(double left, double right, double f(double x));
/* Sample functions */
double cube(double x);
double line(double x);
int main()
{
double left, right, result;
double (*func_ptr)(double a)=cube;/* a function pointer */
printf("This program finds the approximate location of a zero of a function, ");
printf("given endpoints at which the function has opposite signs.\n\n");
printf("Please enter the left and right endpoints of your interval: ");
/* Get endpoints. */
scanf("%lf%lf",&left,&right);

/* Fix endpoints if backwards. */
if(left>right)
	swap(&left,&right);
/* Approximate the root of the specified function between the
 *  endpoints.
 */
result=find_zero(left, right, line);
printf("\nThe result is for the line is %lf.\n",result);
result=find_zero(left, right, cube);
printf("\nThe result is for the cubic is %lf.\n",func_ptr);


return 0;



}


void swap(double *a, double *b)
{
	double temp=*a;
	*a=*b;
	*b=temp;
	return;
}
	
double find_zero(double left, double right, double f(double x))
{
	double new;
	int i;
	assert(f(left)*f(right)<=0);/* Test for opposite signs. */
	/* This loop reduces the size of the interval until it 
	 * locates an approximate root.
	 * */
	while(1)/* Exit only with a return */

	{
		/* Exit if an endpoint is close enough to a root. */
		if(fabs(f(left))<=EPSILON)
			return left;
		if(fabs(f(right))<=EPSILON)
			return right;

		/* Otherwise, find the midpoint. Repeat with a half
		 * of the interval that still has opposite signs 
		 * at the endpoints. 
		 */
		new=(left+right)/2;
		if(fabs(f(new))<=EPSILON)
			return new;
		if (f(new)*f(left)<=0)
			right=new;
		else
			left=new;
		
	}
	
}	
	
double cube(double x)
{
	
	return x*x*x;
}

double line(double x)
{
	return 5*x-10;
}


	
